#define G4 392
#define A4 440
#define B4 494
#define C5 523
#define D5 587
#define E5 659
#define F5 698
#define G5 784
int Buzzer_pin = 33, QTI_L = 39, QTI_R = 36, Button_pin = 18;
int Tone[] = {B4, B4, B4, B4, B4, B4,
              B4, D5, G4, A4, B4,
              C5, C5, C5, C5, C5, B4, B4, B4,
              D5, D5, C5, A4, G4, G5
             };
float Time[] = {0.25, 0.25, 0.5, 0.25, 0.25, 0.5,
                0.25, 0.25, 0.375, 0.125, 1,
                0.25, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25,
                0.25, 0.25, 0.25, 0.25, 0.5, 0.5
               };
int length = sizeof(Tone) / sizeof(Tone[0]);
void setup() {
  pinMode(QTI_L, INPUT);
  pinMode(QTI_R, INPUT);
  ledcSetup(2, 4000, 8);
  ledcAttachPin(Buzzer_pin, 2);
  for (int i = 12; i <= 15; i++) {    
    ledcSetup(i, 255, 8);             
    ledcAttachPin(i, i);              
  }
  while (digitalRead(Button_pin) == 1);
}
void Motor(int L1, int L2 , int R1, int R2) {
  ledcWrite(12, L1);
  ledcWrite(13, L2);
  ledcWrite(14, R1);
  ledcWrite(15, R2);
}
void Tracking() {
  int QTI_Max = digitalRead(QTI_L) * 2 + digitalRead(QTI_R);
  int Speed = 160;
  switch (QTI_Max) {
    case 0:
      Motor(0, Speed, 0 , Speed); break;
    case 2:
      Motor(Speed/2, 0, Speed, 0); break;
    case 1:
      Motor(Speed, 0, Speed/2, 0); break;
    case 3:
      Motor(Speed+40, 0, Speed+40, 0); break;
  }
}
void loop() {
  for (int i = 0; i < length; i++) {
    ledcWriteTone(2, Tone[i]);
    for (int j = 1; j < (Time[i] / 0.025); j++) {
      Tracking();
      delay(25);
    }
    ledcWrite(2, 0);
  }
}
