#include <IRremote.h>
#include <FastLED.h>
CRGB leds[4];
CRGB myRGBcolor(0, 0, 0);
#define RECV_PIN 19
IRrecv irrecv(RECV_PIN);
decode_results results;
int state_L, state_N, Time = 500, Button_pin = 18;
void setup() {
  Serial.begin(9600);
  FastLED.addLeds<WS2812, 25, GRB>(leds, 4); 
  FastLED.setBrightness(100);
  irrecv.enableIRIn();
  pinMode(RECV_PIN, INPUT);
  pinMode(Button_pin, INPUT);
  while (digitalRead(Button_pin) == 1);
}

void IR_remote_control() {
  if (state_N == 0xFF18E7){
    Time += 50;
    if (Time > 1000){
      Time = 1000;
    }
  }
  else if (state_N == 0xFF4AB5){
    Time -= 50;
    if (Time < 50){
      Time = 50;
    }
  }
}
void loop() {
  for (int i = 0; i <= 3; i++) {
    myRGBcolor.r = random(0, 256);           
    myRGBcolor.g = random(0, 256);
    myRGBcolor.b = random(0, 256);
    leds[i] = myRGBcolor;
    FastLED.show();                          
    delay(Time);
    leds[i] = CRGB::Black;                   
    FastLED.show();
    delay(Time);
  }
  if (irrecv.decode(&results)) {
    Serial.println(results.value, HEX);
    if (results.value == 0xFFFFFFFFF) {
      state_N = state_L;
    }
    else {
      state_N = results.value;
      state_L = results.value;
    }
    IR_remote_control();
    irrecv.resume();
  }
  delay(150);
}
